import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Класс Враг. Создается вражеский корабль, организуется его движение и момент удаления с Мира.
 * 
 * @author (Гладкий Роман & Маркин Борис) 
 * @version (v0.7 Beta - 28.06.18)
 */
public class Enemy extends Actor
{
    /**
     * Act - do whatever the Enemy wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    private int vx = 0;
    private boolean toRemove = false;
    
    public Enemy(int v)
    {
        vx = v;
    }
    
    public void adeedToWorld(World Space)
    {
        setRotation(180);
    }
    
    public void move()
    {
        setLocation(getX() + vx, getY());
        Actor actor = getOneIntersectingObject(Player.class);
        if(actor!=null)
        {
            ((Player)actor).Destroy();
            Destroy();
        }
        if(getX() < -100)
        {
            // Enemy is removed when he flies through the map
            toRemove = true;
        }
    }
    
    public void Destroy()
    {
        for(int i = 0; i<10; i++)
        {
            int px = -20 + Greenfoot.getRandomNumber(40);
            int py = -20 + Greenfoot.getRandomNumber(40);
            getWorld().addObject(new Fraction(getImage()), getX() + px, getY() + py);
        }
        getWorld().addObject(new Circle(), getX(), getY());
        toRemove = true;
    }
    
    public void act() 
    {
        if(!toRemove)
        {
            move();
        }
        else
        {
            getWorld().removeObject(this); // Enemy removed
        }
    }
}
