import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Класс Лазер. Устанавливается объект, который будет появляться при нажатии на кнопку мыши.
 * Звук взрыва.
 * 
 * @author (Гладкий Роман & Маркин Борис)
 * @version (v0.7 Beta - 28.06.18)
 */
public class Laser extends Actor
{
    /**
     * Act - do whatever the Laser wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    GreenfootSound Explosion = new GreenfootSound("Explosion_02.mp3");
    
    private boolean toRemove = false;
    
    public void addedToWorld(World Space)
    {
        GreenfootImage image = new GreenfootImage(50,10);
        image.setColor(Color.YELLOW);
        image.drawLine(0, 8, image.getWidth()-10, 8);
        setImage(image);
    }
    
    public void act() 
    {
        if(!toRemove)
        {
            setLocation(getX() + 8, getY()); // Fly speed of laser
            Actor actor = getOneIntersectingObject(Enemy.class);
            if(actor!=null)
            {
                World myWorld = getWorld();
                ((Enemy)actor).Destroy();
                getWorld().removeObject(this); // Laser removed
                Explosion.setVolume(40);
                Explosion.play();
                Space space = (Space)myWorld;
                Counter counter = space.getCounter();
                counter.addScore();
            }
        }
    }
    
}
