import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Класс Игрок. Инициализируется игровое поле с текущими координатами.
 * Также создается разлет осколков если ваш корабль взорвался.
 * Все движения, стрельба, связанные с Игроком, обрабатываются в этом классе.
 * Звук выстрела и звук Game Over.
 * 
 * @author (Гладкий Роман & Маркин Борис) 
 * @version (v0.7 Beta - 28.06.18)
 */
public class Player extends Actor
{
    
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    GreenfootSound Laser = new GreenfootSound("Hit.mp3");
    GreenfootSound GameOver = new GreenfootSound("Impact_Sweep.mp3");
    
    private int target_X = 0, target_Y = 0;
    private boolean toRemove = false;
    
    public void addedToWorld(World Space)
    {
        target_X = getX();
        target_Y = getY();
    }
    
    public void Destroy()
    {
        for(int i = 0; i<10; i++)
        {
            int px = -20 + Greenfoot.getRandomNumber(40);
            int py = -20 + Greenfoot.getRandomNumber(40);
            getWorld().addObject(new Fraction(getImage()), getX() + px, getY() + py);
        }
        getWorld().addObject(new Circle(), getX(), getY());
        toRemove = true;
    }
    
    public void move()
    {
        double r_X = target_X - getX();
        double r_Y = target_Y - getY();
        double r = Math.sqrt(r_X * r_X + r_Y * r_Y);
        int bts = 60;
        int pos_X = 0, pos_Y = 0;
        if (r > bts)
        {
            pos_X = (int)(getX() + bts * r_X / r);
            pos_Y = (int)(getY() + bts * r_Y / r);
        }
        else
        {
            pos_X = target_X;
            pos_Y = target_Y;
        }
        setLocation(pos_X, pos_Y);
    }
    
    public void shooter()
    {
        if(Greenfoot.mousePressed(null))
        {
            getWorld().addObject(new Laser(), getX() + 80, getY() - 2);
            Laser.setVolume(30);
            Laser.play();
        }
        if(Greenfoot.mouseDragged(null))
        {
            MouseInfo Mouse = Greenfoot.getMouseInfo();
            target_X = Mouse.getX();
            target_Y = Mouse.getY();
        }
   }
    
    public void act() 
    {
        if(Greenfoot.mouseMoved(null))
        {
            MouseInfo Mouse = Greenfoot.getMouseInfo();
            target_X = Mouse.getX();
            target_Y = Mouse.getY();
        }
        move();
        shooter();
        if(toRemove)
        {
            isGameOver gameover = new isGameOver();
            getWorld().addObject(gameover, getWorld().getWidth() / 2, getWorld().getHeight() / 2);
            getWorld().removeObject(this);
            GameOver.setVolume(50);
            GameOver.play();
        }
    }
}
